/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"time"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
)

// sarefConsistsOfMultipleSarefDevice is interface for property SarefConsistsOf with multiple type SarefDevice
type sarefConsistsOfMultipleSarefDevice interface {
	SarefConsistsOf() []SarefDevice // A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
	SetSarefConsistsOf([]SarefDevice) error // set A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
	AddSarefConsistsOf(...SarefDevice) error // add A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
	DelSarefConsistsOf(...SarefDevice) error // delete A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
}

// sarefControlsPropertyMultipleSarefProperty is interface for property SarefControlsProperty with multiple type SarefProperty
type sarefControlsPropertyMultipleSarefProperty interface {
	SarefControlsProperty() []SarefProperty // A relationship specifying the Property that can be controlled by a certain Device
	SetSarefControlsProperty([]SarefProperty) error // set A relationship specifying the Property that can be controlled by a certain Device
	AddSarefControlsProperty(...SarefProperty) error // add A relationship specifying the Property that can be controlled by a certain Device
	DelSarefControlsProperty(...SarefProperty) error // delete A relationship specifying the Property that can be controlled by a certain Device
}

// sarefHasProfileMultipleSarefProfile is interface for property SarefHasProfile with multiple type SarefProfile
type sarefHasProfileMultipleSarefProfile interface {
	SarefHasProfile() []SarefProfile // A relationship associating a profile to a certain entity (e.g., a device)
	SetSarefHasProfile([]SarefProfile) error // set A relationship associating a profile to a certain entity (e.g., a device)
	AddSarefHasProfile(...SarefProfile) error // add A relationship associating a profile to a certain entity (e.g., a device)
	DelSarefHasProfile(...SarefProfile) error // delete A relationship associating a profile to a certain entity (e.g., a device)
}

// sarefHasStateMultipleSarefState is interface for property SarefHasState with multiple type SarefState
type sarefHasStateMultipleSarefState interface {
	SarefHasState() []SarefState // A relationship identifying the type of state of a device
	SetSarefHasState([]SarefState) error // set A relationship identifying the type of state of a device
	AddSarefHasState(...SarefState) error // add A relationship identifying the type of state of a device
	DelSarefHasState(...SarefState) error // delete A relationship identifying the type of state of a device
}

// sarefHasTypicalConsumptionMultipleSarefProperty is interface for property SarefHasTypicalConsumption with multiple type SarefProperty
type sarefHasTypicalConsumptionMultipleSarefProperty interface {
	SarefHasTypicalConsumption() []SarefProperty // A relationship identifying the typical (energy or power) consumption of a device
	SetSarefHasTypicalConsumption([]SarefProperty) error // set A relationship identifying the typical (energy or power) consumption of a device
	AddSarefHasTypicalConsumption(...SarefProperty) error // add A relationship identifying the typical (energy or power) consumption of a device
	DelSarefHasTypicalConsumption(...SarefProperty) error // delete A relationship identifying the typical (energy or power) consumption of a device
}

// sarefIsUsedForMultipleSarefCommodity is interface for property SarefIsUsedFor with multiple type SarefCommodity
type sarefIsUsedForMultipleSarefCommodity interface {
	SarefIsUsedFor() []SarefCommodity // A relationship specifying the purpose for which a device is used for (e.g., controlling a Commodity)
	SetSarefIsUsedFor([]SarefCommodity) error // set A relationship specifying the purpose for which a device is used for (e.g., controlling a Commodity)
	AddSarefIsUsedFor(...SarefCommodity) error // add A relationship specifying the purpose for which a device is used for (e.g., controlling a Commodity)
	DelSarefIsUsedFor(...SarefCommodity) error // delete A relationship specifying the purpose for which a device is used for (e.g., controlling a Commodity)
}

// sarefMakesMeasurementMultipleSarefMeasurement is interface for property SarefMakesMeasurement with multiple type SarefMeasurement
type sarefMakesMeasurementMultipleSarefMeasurement interface {
	SarefMakesMeasurement() []SarefMeasurement // A relation between a device and the measurements it makes. Such measurement will link together the value of the measurement, its unit of measure and the property to which it relates.
	SetSarefMakesMeasurement([]SarefMeasurement) error // set A relation between a device and the measurements it makes. Such measurement will link together the value of the measurement, its unit of measure and the property to which it relates.
	AddSarefMakesMeasurement(...SarefMeasurement) error // add A relation between a device and the measurements it makes. Such measurement will link together the value of the measurement, its unit of measure and the property to which it relates.
	DelSarefMakesMeasurement(...SarefMeasurement) error // delete A relation between a device and the measurements it makes. Such measurement will link together the value of the measurement, its unit of measure and the property to which it relates.
}

// sarefMeasuresPropertyMultipleSarefProperty is interface for property SarefMeasuresProperty with multiple type SarefProperty
type sarefMeasuresPropertyMultipleSarefProperty interface {
	SarefMeasuresProperty() []SarefProperty // A relationship specifying the Property that can be measured by a certain Device
	SetSarefMeasuresProperty([]SarefProperty) error // set A relationship specifying the Property that can be measured by a certain Device
	AddSarefMeasuresProperty(...SarefProperty) error // add A relationship specifying the Property that can be measured by a certain Device
	DelSarefMeasuresProperty(...SarefProperty) error // delete A relationship specifying the Property that can be measured by a certain Device
}

// sarefOffersMultipleSarefService is interface for property SarefOffers with multiple type SarefService
type sarefOffersMultipleSarefService interface {
	SarefOffers() []SarefService // A relationship between a device and a service
	SetSarefOffers([]SarefService) error // set A relationship between a device and a service
	AddSarefOffers(...SarefService) error // add A relationship between a device and a service
	DelSarefOffers(...SarefService) error // delete A relationship between a device and a service
}

// sarefAccomplishesMultipleSarefTask is interface for property SarefAccomplishes with multiple type SarefTask
type sarefAccomplishesMultipleSarefTask interface {
	SarefAccomplishes() []SarefTask // A relationship between a certain entity (e.g., a device) and the task it accomplishes
	SetSarefAccomplishes([]SarefTask) error // set A relationship between a certain entity (e.g., a device) and the task it accomplishes
	AddSarefAccomplishes(...SarefTask) error // add A relationship between a certain entity (e.g., a device) and the task it accomplishes
	DelSarefAccomplishes(...SarefTask) error // delete A relationship between a certain entity (e.g., a device) and the task it accomplishes
}

// sarefHasFunctionMultipleSarefFunction is interface for property SarefHasFunction with multiple type SarefFunction
type sarefHasFunctionMultipleSarefFunction interface {
	SarefHasFunction() []SarefFunction // A relationship identifying the type of function of a device
	SetSarefHasFunction([]SarefFunction) error // set A relationship identifying the type of function of a device
	AddSarefHasFunction(...SarefFunction) error // add A relationship identifying the type of function of a device
	DelSarefHasFunction(...SarefFunction) error // delete A relationship identifying the type of function of a device
}

// sarefHasDescriptionSinglestring is interface for property SarefHasDescription with single type string
type sarefHasDescriptionSinglestring interface {
	SarefHasDescription() string // A relationship providing a description of an entity (e.g., device)
	SetSarefHasDescription(string) error // set A relationship providing a description of an entity (e.g., device)
}

// sarefHasManufacturerSinglestring is interface for property SarefHasManufacturer with single type string
type sarefHasManufacturerSinglestring interface {
	SarefHasManufacturer() string // A relationship identifying the manufacturer of an entity (e.g., device)
	SetSarefHasManufacturer(string) error // set A relationship identifying the manufacturer of an entity (e.g., device)
}

// sarefHasModelSinglestring is interface for property SarefHasModel with single type string
type sarefHasModelSinglestring interface {
	SarefHasModel() string // A relationship identifying the model of an entity (e.g., device)
	SetSarefHasModel(string) error // set A relationship identifying the model of an entity (e.g., device)
}

// sarefActsUponMultipleSarefState is interface for property SarefActsUpon with multiple type SarefState
type sarefActsUponMultipleSarefState interface {
	SarefActsUpon() []SarefState // A relationship between a command and a state
	SetSarefActsUpon([]SarefState) error // set A relationship between a command and a state
	AddSarefActsUpon(...SarefState) error // add A relationship between a command and a state
	DelSarefActsUpon(...SarefState) error // delete A relationship between a command and a state
}

// sarefIsCommandOfMultipleSarefFunction is interface for property SarefIsCommandOf with multiple type SarefFunction
type sarefIsCommandOfMultipleSarefFunction interface {
	SarefIsCommandOf() []SarefFunction // A relationship between a command and a function.
	SetSarefIsCommandOf([]SarefFunction) error // set A relationship between a command and a function.
	AddSarefIsCommandOf(...SarefFunction) error // add A relationship between a command and a function.
	DelSarefIsCommandOf(...SarefFunction) error // delete A relationship between a command and a function.
}

// timeAfterSingleTimeTemporalEntity is interface for property TimeAfter with single type TimeTemporalEntity
type timeAfterSingleTimeTemporalEntity interface {
	TimeAfter() TimeTemporalEntity // Gives directionality to time. If a temporal entity T1 is after another temporal entity T2, then the beginning of T1 is after the end of T2.
	SetTimeAfter(TimeTemporalEntity) error // set Gives directionality to time. If a temporal entity T1 is after another temporal entity T2, then the beginning of T1 is after the end of T2.
}

// timeHasBeginningSingleTimeInstant is interface for property TimeHasBeginning with single type TimeInstant
type timeHasBeginningSingleTimeInstant interface {
	TimeHasBeginning() TimeInstant // Beginning of a temporal entity
	SetTimeHasBeginning(TimeInstant) error // set Beginning of a temporal entity
}

// timeBeforeSingleTimeTemporalEntity is interface for property TimeBefore with single type TimeTemporalEntity
type timeBeforeSingleTimeTemporalEntity interface {
	TimeBefore() TimeTemporalEntity // Gives directionality to time. If a temporal entity T1 is before another temporal entity T2, then the end of T1 is before the beginning of T2. Thus, \"before\" can be considered to be basic to instants and derived for intervals.
	SetTimeBefore(TimeTemporalEntity) error // set Gives directionality to time. If a temporal entity T1 is before another temporal entity T2, then the end of T1 is before the beginning of T2. Thus, \"before\" can be considered to be basic to instants and derived for intervals.
}

// timeHasTemporalDurationSingleTimeTemporalDuration is interface for property TimeHasTemporalDuration with single type TimeTemporalDuration
type timeHasTemporalDurationSingleTimeTemporalDuration interface {
	TimeHasTemporalDuration() TimeTemporalDuration // Duration of a temporal entity.
	SetTimeHasTemporalDuration(TimeTemporalDuration) error // set Duration of a temporal entity.
}

// timeHasXSDDurationSingleDuration is interface for property TimeHasXSDDuration with single type time.Duration
type timeHasXSDDurationSingleDuration interface {
	TimeHasXSDDuration() time.Duration // Extent of a temporal entity, expressed using xsd:duration
	SetTimeHasXSDDuration(time.Duration) error // set Extent of a temporal entity, expressed using xsd:duration
}

// timeHasEndSingleTimeInstant is interface for property TimeHasEnd with single type TimeInstant
type timeHasEndSingleTimeInstant interface {
	TimeHasEnd() TimeInstant // End of a temporal entity.
	SetTimeHasEnd(TimeInstant) error // set End of a temporal entity.
}

// timeInsideSingleTimeInstant is interface for property TimeInside with single type TimeInstant
type timeInsideSingleTimeInstant interface {
	TimeInside() TimeInstant // An instant that falls inside the interval. It is not intended to include beginnings and ends of intervals.
	SetTimeInside(TimeInstant) error // set An instant that falls inside the interval. It is not intended to include beginnings and ends of intervals.
}

// sarefIsMeasuredInMultipleSarefUnitOfMeasure is interface for property SarefIsMeasuredIn with multiple type SarefUnitOfMeasure
type sarefIsMeasuredInMultipleSarefUnitOfMeasure interface {
	SarefIsMeasuredIn() []SarefUnitOfMeasure // A relationship identifying the unit of measure used for a certain entity.
	SetSarefIsMeasuredIn([]SarefUnitOfMeasure) error // set A relationship identifying the unit of measure used for a certain entity.
	AddSarefIsMeasuredIn(...SarefUnitOfMeasure) error // add A relationship identifying the unit of measure used for a certain entity.
	DelSarefIsMeasuredIn(...SarefUnitOfMeasure) error // delete A relationship identifying the unit of measure used for a certain entity.
}

// timeIntervalEqualsSingleTimeProperInterval is interface for property TimeIntervalEquals with single type TimeProperInterval
type timeIntervalEqualsSingleTimeProperInterval interface {
	TimeIntervalEquals() TimeProperInterval // If a proper interval T1 is intervalEquals another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is coincident with the end of T2.
	SetTimeIntervalEquals(TimeProperInterval) error // set If a proper interval T1 is intervalEquals another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is coincident with the end of T2.
}

// timeIntervalStartsSingleTimeProperInterval is interface for property TimeIntervalStarts with single type TimeProperInterval
type timeIntervalStartsSingleTimeProperInterval interface {
	TimeIntervalStarts() TimeProperInterval // If a proper interval T1 is intervalStarts another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is before the end of T2.
	SetTimeIntervalStarts(TimeProperInterval) error // set If a proper interval T1 is intervalStarts another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is before the end of T2.
}

// timeIntervalContainsSingleTimeProperInterval is interface for property TimeIntervalContains with single type TimeProperInterval
type timeIntervalContainsSingleTimeProperInterval interface {
	TimeIntervalContains() TimeProperInterval // If a proper interval T1 is intervalContains another proper interval T2, then the beginning of T1 is before the beginning of T2, and the end of T1 is after the end of T2.
	SetTimeIntervalContains(TimeProperInterval) error // set If a proper interval T1 is intervalContains another proper interval T2, then the beginning of T1 is before the beginning of T2, and the end of T1 is after the end of T2.
}

// timeIntervalDisjointSingleTimeProperInterval is interface for property TimeIntervalDisjoint with single type TimeProperInterval
type timeIntervalDisjointSingleTimeProperInterval interface {
	TimeIntervalDisjoint() TimeProperInterval // If a proper interval T1 is intervalDisjoint another proper interval T2, then the beginning of T1 is after the end of T2, or the end of T1 is before the beginning of T2, i.e. the intervals do not overlap in any way, but their ordering relationship is not known.
	SetTimeIntervalDisjoint(TimeProperInterval) error // set If a proper interval T1 is intervalDisjoint another proper interval T2, then the beginning of T1 is after the end of T2, or the end of T1 is before the beginning of T2, i.e. the intervals do not overlap in any way, but their ordering relationship is not known.
}

// timeIntervalMeetsSingleTimeProperInterval is interface for property TimeIntervalMeets with single type TimeProperInterval
type timeIntervalMeetsSingleTimeProperInterval interface {
	TimeIntervalMeets() TimeProperInterval // If a proper interval T1 is intervalMeets another proper interval T2, then the end of T1 is coincident with the beginning of T2.
	SetTimeIntervalMeets(TimeProperInterval) error // set If a proper interval T1 is intervalMeets another proper interval T2, then the end of T1 is coincident with the beginning of T2.
}

// timeIntervalAfterSingleTimeProperInterval is interface for property TimeIntervalAfter with single type TimeProperInterval
type timeIntervalAfterSingleTimeProperInterval interface {
	TimeIntervalAfter() TimeProperInterval // If a proper interval T1 is intervalAfter another proper interval T2, then the beginning of T1 is after the end of T2.
	SetTimeIntervalAfter(TimeProperInterval) error // set If a proper interval T1 is intervalAfter another proper interval T2, then the beginning of T1 is after the end of T2.
}

// timeIntervalOverlapsSingleTimeProperInterval is interface for property TimeIntervalOverlaps with single type TimeProperInterval
type timeIntervalOverlapsSingleTimeProperInterval interface {
	TimeIntervalOverlaps() TimeProperInterval // If a proper interval T1 is intervalOverlaps another proper interval T2, then the beginning of T1 is before the beginning of T2, the end of T1 is after the beginning of T2, and the end of T1 is before the end of T2.
	SetTimeIntervalOverlaps(TimeProperInterval) error // set If a proper interval T1 is intervalOverlaps another proper interval T2, then the beginning of T1 is before the beginning of T2, the end of T1 is after the beginning of T2, and the end of T1 is before the end of T2.
}

// timeIntervalFinishedBySingleTimeProperInterval is interface for property TimeIntervalFinishedBy with single type TimeProperInterval
type timeIntervalFinishedBySingleTimeProperInterval interface {
	TimeIntervalFinishedBy() TimeProperInterval // If a proper interval T1 is intervalFinishedBy another proper interval T2, then the beginning of T1 is before the beginning of T2, and the end of T1 is coincident with the end of T2.
	SetTimeIntervalFinishedBy(TimeProperInterval) error // set If a proper interval T1 is intervalFinishedBy another proper interval T2, then the beginning of T1 is before the beginning of T2, and the end of T1 is coincident with the end of T2.
}

// timeIntervalOverlappedBySingleTimeProperInterval is interface for property TimeIntervalOverlappedBy with single type TimeProperInterval
type timeIntervalOverlappedBySingleTimeProperInterval interface {
	TimeIntervalOverlappedBy() TimeProperInterval // If a proper interval T1 is intervalOverlappedBy another proper interval T2, then the beginning of T1 is after the beginning of T2, the beginning of T1 is before the end of T2, and the end of T1 is after the end of T2.
	SetTimeIntervalOverlappedBy(TimeProperInterval) error // set If a proper interval T1 is intervalOverlappedBy another proper interval T2, then the beginning of T1 is after the beginning of T2, the beginning of T1 is before the end of T2, and the end of T1 is after the end of T2.
}

// timeIntervalBeforeSingleTimeProperInterval is interface for property TimeIntervalBefore with single type TimeProperInterval
type timeIntervalBeforeSingleTimeProperInterval interface {
	TimeIntervalBefore() TimeProperInterval // If a proper interval T1 is intervalBefore another proper interval T2, then the end of T1 is before the beginning of T2.
	SetTimeIntervalBefore(TimeProperInterval) error // set If a proper interval T1 is intervalBefore another proper interval T2, then the end of T1 is before the beginning of T2.
}

// timeIntervalDuringSingleTimeProperInterval is interface for property TimeIntervalDuring with single type TimeProperInterval
type timeIntervalDuringSingleTimeProperInterval interface {
	TimeIntervalDuring() TimeProperInterval // If a proper interval T1 is intervalDuring another proper interval T2, then the beginning of T1 is after the beginning of T2, and the end of T1 is before the end of T2.
	SetTimeIntervalDuring(TimeProperInterval) error // set If a proper interval T1 is intervalDuring another proper interval T2, then the beginning of T1 is after the beginning of T2, and the end of T1 is before the end of T2.
}

// timeIntervalStartedBySingleTimeProperInterval is interface for property TimeIntervalStartedBy with single type TimeProperInterval
type timeIntervalStartedBySingleTimeProperInterval interface {
	TimeIntervalStartedBy() TimeProperInterval // If a proper interval T1 is intervalStarted another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is after the end of T2.
	SetTimeIntervalStartedBy(TimeProperInterval) error // set If a proper interval T1 is intervalStarted another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is after the end of T2.
}

// timeIntervalFinishesSingleTimeProperInterval is interface for property TimeIntervalFinishes with single type TimeProperInterval
type timeIntervalFinishesSingleTimeProperInterval interface {
	TimeIntervalFinishes() TimeProperInterval // If a proper interval T1 is intervalFinishes another proper interval T2, then the beginning of T1 is after the beginning of T2, and the end of T1 is coincident with the end of T2.
	SetTimeIntervalFinishes(TimeProperInterval) error // set If a proper interval T1 is intervalFinishes another proper interval T2, then the beginning of T1 is after the beginning of T2, and the end of T1 is coincident with the end of T2.
}

// timeIntervalInSingleTimeProperInterval is interface for property TimeIntervalIn with single type TimeProperInterval
type timeIntervalInSingleTimeProperInterval interface {
	TimeIntervalIn() TimeProperInterval // If a proper interval T1 is intervalIn another proper interval T2, then the beginning of T1 is after the beginning of T2 or is coincident with the beginning of T2, and the end of T1 is before the end of T2, or is coincident with the end of T2, except that end of T1 may not be coincident with the end of T2 if the beginning of T1 is coincident with the beginning of T2.
	SetTimeIntervalIn(TimeProperInterval) error // set If a proper interval T1 is intervalIn another proper interval T2, then the beginning of T1 is after the beginning of T2 or is coincident with the beginning of T2, and the end of T1 is before the end of T2, or is coincident with the end of T2, except that end of T1 may not be coincident with the end of T2 if the beginning of T1 is coincident with the beginning of T2.
}

// timeIntervalMetBySingleTimeProperInterval is interface for property TimeIntervalMetBy with single type TimeProperInterval
type timeIntervalMetBySingleTimeProperInterval interface {
	TimeIntervalMetBy() TimeProperInterval // If a proper interval T1 is intervalMetBy another proper interval T2, then the beginning of T1 is coincident with the end of T2.
	SetTimeIntervalMetBy(TimeProperInterval) error // set If a proper interval T1 is intervalMetBy another proper interval T2, then the beginning of T1 is coincident with the end of T2.
}

// timeHasDateTimeDescriptionSingleTimeGeneralDateTimeDescription is interface for property TimeHasDateTimeDescription with single type TimeGeneralDateTimeDescription
type timeHasDateTimeDescriptionSingleTimeGeneralDateTimeDescription interface {
	TimeHasDateTimeDescription() TimeGeneralDateTimeDescription // Value of DateTimeInterval expressed as a structured value. The beginning and end of the interval coincide with the limits of the shortest element in the description.
	SetTimeHasDateTimeDescription(TimeGeneralDateTimeDescription) error // set Value of DateTimeInterval expressed as a structured value. The beginning and end of the interval coincide with the limits of the shortest element in the description.
}

// timeXsdDateTimeSingleTime is interface for property TimeXsdDateTime with single type time.Time
type timeXsdDateTimeSingleTime interface {
	TimeXsdDateTime() time.Time // Value of DateTimeInterval expressed as a compact value.
	SetTimeXsdDateTime(time.Time) error // set Value of DateTimeInterval expressed as a compact value.
}

// sarefIsControlledByDeviceMultipleSarefDevice is interface for property SarefIsControlledByDevice with multiple type SarefDevice
type sarefIsControlledByDeviceMultipleSarefDevice interface {
	SarefIsControlledByDevice() []SarefDevice // A relationship specifying the devices that can control a certain property
	SetSarefIsControlledByDevice([]SarefDevice) error // set A relationship specifying the devices that can control a certain property
	AddSarefIsControlledByDevice(...SarefDevice) error // add A relationship specifying the devices that can control a certain property
	DelSarefIsControlledByDevice(...SarefDevice) error // delete A relationship specifying the devices that can control a certain property
}

// sarefIsMeasuredByDeviceMultipleSarefDevice is interface for property SarefIsMeasuredByDevice with multiple type SarefDevice
type sarefIsMeasuredByDeviceMultipleSarefDevice interface {
	SarefIsMeasuredByDevice() []SarefDevice // A relationship specifying the devices that can measure a certain property
	SetSarefIsMeasuredByDevice([]SarefDevice) error // set A relationship specifying the devices that can measure a certain property
	AddSarefIsMeasuredByDevice(...SarefDevice) error // add A relationship specifying the devices that can measure a certain property
	DelSarefIsMeasuredByDevice(...SarefDevice) error // delete A relationship specifying the devices that can measure a certain property
}

// sarefRelatesToMeasurementMultipleSarefMeasurement is interface for property SarefRelatesToMeasurement with multiple type SarefMeasurement
type sarefRelatesToMeasurementMultipleSarefMeasurement interface {
	SarefRelatesToMeasurement() []SarefMeasurement // A relationship between a property and the measurements it relates to
	SetSarefRelatesToMeasurement([]SarefMeasurement) error // set A relationship between a property and the measurements it relates to
	AddSarefRelatesToMeasurement(...SarefMeasurement) error // add A relationship between a property and the measurements it relates to
	DelSarefRelatesToMeasurement(...SarefMeasurement) error // delete A relationship between a property and the measurements it relates to
}

// timeHasTRSSingleTimeTRS is interface for property TimeHasTRS with single type TimeTRS
type timeHasTRSSingleTimeTRS interface {
	TimeHasTRS() TimeTRS // The temporal reference system used by a temporal position or extent description. 
	SetTimeHasTRS(TimeTRS) error // set The temporal reference system used by a temporal position or extent description. 
}

// timeUnitTypeSingleTimeTemporalUnit is interface for property TimeUnitType with single type TimeTemporalUnit
type timeUnitTypeSingleTimeTemporalUnit interface {
	TimeUnitType() TimeTemporalUnit // The temporal unit which provides the precision of a date-time value or scale of a temporal extent
	SetTimeUnitType(TimeTemporalUnit) error // set The temporal unit which provides the precision of a date-time value or scale of a temporal extent
}

// timeDayOfWeekSingleTimeDayOfWeek is interface for property TimeDayOfWeek with single type TimeDayOfWeek
type timeDayOfWeekSingleTimeDayOfWeek interface {
	TimeDayOfWeek() TimeDayOfWeek // The day of week, whose value is a member of the class time:DayOfWeek
	SetTimeDayOfWeek(TimeDayOfWeek) error // set The day of week, whose value is a member of the class time:DayOfWeek
}

// timeDayOfYearSingleint is interface for property TimeDayOfYear with single type int
type timeDayOfYearSingleint interface {
	TimeDayOfYear() int // The number of the day within the year
	SetTimeDayOfYear(int) error // set The number of the day within the year
}

// timeHourSingleint is interface for property TimeHour with single type int
type timeHourSingleint interface {
	TimeHour() int // Hour position in a calendar-clock system.
	SetTimeHour(int) error // set Hour position in a calendar-clock system.
}

// timeMinuteSingleint is interface for property TimeMinute with single type int
type timeMinuteSingleint interface {
	TimeMinute() int // Minute position in a calendar-clock system.
	SetTimeMinute(int) error // set Minute position in a calendar-clock system.
}

// timeMonthOfYearSingleTimeMonthOfYear is interface for property TimeMonthOfYear with single type TimeMonthOfYear
type timeMonthOfYearSingleTimeMonthOfYear interface {
	TimeMonthOfYear() TimeMonthOfYear // The month of the year, whose value is a member of the class time:MonthOfYear
	SetTimeMonthOfYear(TimeMonthOfYear) error // set The month of the year, whose value is a member of the class time:MonthOfYear
}

// timeSecondSinglefloat64 is interface for property TimeSecond with single type float64
type timeSecondSinglefloat64 interface {
	TimeSecond() float64 // Second position in a calendar-clock system.
	SetTimeSecond(float64) error // set Second position in a calendar-clock system.
}

// timeZoneSingleTimeZone is interface for property TimeZone with single type TimeZone
type timeZoneSingleTimeZone interface {
	TimeZone() TimeZone // The time zone for clock elements in the temporal position
	SetTimeZone(TimeZone) error // set The time zone for clock elements in the temporal position
}

// timeWeekSingleint is interface for property TimeWeek with single type int
type timeWeekSingleint interface {
	TimeWeek() int // Week number within the year.
	SetTimeWeek(int) error // set Week number within the year.
}

// sarefIsOfferedByMultipleSarefDevice is interface for property SarefIsOfferedBy with multiple type SarefDevice
type sarefIsOfferedByMultipleSarefDevice interface {
	SarefIsOfferedBy() []SarefDevice // A relationship between a service and a device that offers the service
	SetSarefIsOfferedBy([]SarefDevice) error // set A relationship between a service and a device that offers the service
	AddSarefIsOfferedBy(...SarefDevice) error // add A relationship between a service and a device that offers the service
	DelSarefIsOfferedBy(...SarefDevice) error // delete A relationship between a service and a device that offers the service
}

// sarefRepresentsMultipleSarefFunction is interface for property SarefRepresents with multiple type SarefFunction
type sarefRepresentsMultipleSarefFunction interface {
	SarefRepresents() []SarefFunction // A relationship between a service and a function.
	SetSarefRepresents([]SarefFunction) error // set A relationship between a service and a function.
	AddSarefRepresents(...SarefFunction) error // add A relationship between a service and a function.
	DelSarefRepresents(...SarefFunction) error // delete A relationship between a service and a function.
}

// sarefHasCommandMultipleSarefCommand is interface for property SarefHasCommand with multiple type SarefCommand
type sarefHasCommandMultipleSarefCommand interface {
	SarefHasCommand() []SarefCommand // A relationship between an entity (such as a function) and a command
	SetSarefHasCommand([]SarefCommand) error // set A relationship between an entity (such as a function) and a command
	AddSarefHasCommand(...SarefCommand) error // add A relationship between an entity (such as a function) and a command
	DelSarefHasCommand(...SarefCommand) error // delete A relationship between an entity (such as a function) and a command
}

// sarefHasThresholdMeasurementMultipleSarefMeasurement is interface for property SarefHasThresholdMeasurement with multiple type SarefMeasurement
type sarefHasThresholdMeasurementMultipleSarefMeasurement interface {
	SarefHasThresholdMeasurement() []SarefMeasurement // A relationship associated with an event function to notify that a certain threshold measurement has been exceeded
	SetSarefHasThresholdMeasurement([]SarefMeasurement) error // set A relationship associated with an event function to notify that a certain threshold measurement has been exceeded
	AddSarefHasThresholdMeasurement(...SarefMeasurement) error // add A relationship associated with an event function to notify that a certain threshold measurement has been exceeded
	DelSarefHasThresholdMeasurement(...SarefMeasurement) error // delete A relationship associated with an event function to notify that a certain threshold measurement has been exceeded
}

// sarefHasSensingRangeMultipleSarefMeasurement is interface for property SarefHasSensingRange with multiple type SarefMeasurement
type sarefHasSensingRangeMultipleSarefMeasurement interface {
	SarefHasSensingRange() []SarefMeasurement // A relationship between a sensing function and a measurement identifying the range of a sensor detection
	SetSarefHasSensingRange([]SarefMeasurement) error // set A relationship between a sensing function and a measurement identifying the range of a sensor detection
	AddSarefHasSensingRange(...SarefMeasurement) error // add A relationship between a sensing function and a measurement identifying the range of a sensor detection
	DelSarefHasSensingRange(...SarefMeasurement) error // delete A relationship between a sensing function and a measurement identifying the range of a sensor detection
}

// sarefHasSensorTypeMultipleSarefProperty is interface for property SarefHasSensorType with multiple type SarefProperty
type sarefHasSensorTypeMultipleSarefProperty interface {
	SarefHasSensorType() []SarefProperty // A relationship identifying the sensing type of a sensor detection (i.e., Temperature, Occupancy, Humidity, Motion , Smoke, Pressure, etc.) 
	SetSarefHasSensorType([]SarefProperty) error // set A relationship identifying the sensing type of a sensor detection (i.e., Temperature, Occupancy, Humidity, Motion , Smoke, Pressure, etc.) 
	AddSarefHasSensorType(...SarefProperty) error // add A relationship identifying the sensing type of a sensor detection (i.e., Temperature, Occupancy, Humidity, Motion , Smoke, Pressure, etc.) 
	DelSarefHasSensorType(...SarefProperty) error // delete A relationship identifying the sensing type of a sensor detection (i.e., Temperature, Occupancy, Humidity, Motion , Smoke, Pressure, etc.) 
}

// timeDaySingleTime is interface for property TimeDay with single type time.Time
type timeDaySingleTime interface {
	TimeDay() time.Time // Day position in a calendar-clock system.The range of this property is not specified, so can be replaced by any specific representation of a calendar day from any calendar. 
	SetTimeDay(time.Time) error // set Day position in a calendar-clock system.The range of this property is not specified, so can be replaced by any specific representation of a calendar day from any calendar. 
}

// timeMonthSingleTime is interface for property TimeMonth with single type time.Time
type timeMonthSingleTime interface {
	TimeMonth() time.Time // Month position in a calendar-clock system.The range of this property is not specified, so can be replaced by any specific representation of a calendar month from any calendar. 
	SetTimeMonth(time.Time) error // set Month position in a calendar-clock system.The range of this property is not specified, so can be replaced by any specific representation of a calendar month from any calendar. 
}

// timeYearSingleTime is interface for property TimeYear with single type time.Time
type timeYearSingleTime interface {
	TimeYear() time.Time // Year position in a calendar-clock system.The range of this property is not specified, so can be replaced by any specific representation of a calendar year from any calendar. 
	SetTimeYear(time.Time) error // set Year position in a calendar-clock system.The range of this property is not specified, so can be replaced by any specific representation of a calendar year from any calendar. 
}

// sarefIsAccomplishedByMultipleSarefDevice is interface for property SarefIsAccomplishedBy with multiple type SarefDevice
type sarefIsAccomplishedByMultipleSarefDevice interface {
	SarefIsAccomplishedBy() []SarefDevice // A relationship indentifying the task accomplished by a certain entity (e.g., a device)
	SetSarefIsAccomplishedBy([]SarefDevice) error // set A relationship indentifying the task accomplished by a certain entity (e.g., a device)
	AddSarefIsAccomplishedBy(...SarefDevice) error // add A relationship indentifying the task accomplished by a certain entity (e.g., a device)
	DelSarefIsAccomplishedBy(...SarefDevice) error // delete A relationship indentifying the task accomplished by a certain entity (e.g., a device)
}

// timeNumericPositionSinglefloat64 is interface for property TimeNumericPosition with single type float64
type timeNumericPositionSinglefloat64 interface {
	TimeNumericPosition() float64 // The (numeric) value indicating position within a temporal coordinate system 
	SetTimeNumericPosition(float64) error // set The (numeric) value indicating position within a temporal coordinate system 
}

// timeNominalPositionSinglestring is interface for property TimeNominalPosition with single type string
type timeNominalPositionSinglestring interface {
	TimeNominalPosition() string // The (nominal) value indicating temporal position in an ordinal reference system 
	SetTimeNominalPosition(string) error // set The (nominal) value indicating temporal position in an ordinal reference system 
}

// sarefConsistsOfMultipleSarefProfile is interface for property SarefConsistsOf with multiple type SarefProfile
type sarefConsistsOfMultipleSarefProfile interface {
	SarefConsistsOf() []SarefProfile // A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
	SetSarefConsistsOf([]SarefProfile) error // set A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
	AddSarefConsistsOf(...SarefProfile) error // add A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
	DelSarefConsistsOf(...SarefProfile) error // delete A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
}

// sarefHasPriceMultipleSarefPrice is interface for property SarefHasPrice with multiple type SarefPrice
type sarefHasPriceMultipleSarefPrice interface {
	SarefHasPrice() []SarefPrice // A relationships indentifying the price associated to an entity
	SetSarefHasPrice([]SarefPrice) error // set A relationships indentifying the price associated to an entity
	AddSarefHasPrice(...SarefPrice) error // add A relationships indentifying the price associated to an entity
	DelSarefHasPrice(...SarefPrice) error // delete A relationships indentifying the price associated to an entity
}

// sarefHasTimeMultipleSarefTime is interface for property SarefHasTime with multiple type SarefTime
type sarefHasTimeMultipleSarefTime interface {
	SarefHasTime() []SarefTime // A relationship to associate time information to an entity
	SetSarefHasTime([]SarefTime) error // set A relationship to associate time information to an entity
	AddSarefHasTime(...SarefTime) error // add A relationship to associate time information to an entity
	DelSarefHasTime(...SarefTime) error // delete A relationship to associate time information to an entity
}

// sarefIsAboutMultipleThing is interface for property SarefIsAbout with multiple type owl.Thing
type sarefIsAboutMultipleThing interface {
	SarefIsAbout() []owl.Thing // A relationship identifying what an entity, such as a Profile, is about
	SetSarefIsAbout([]owl.Thing) error // set A relationship identifying what an entity, such as a Profile, is about
	AddSarefIsAbout(...owl.Thing) error // add A relationship identifying what an entity, such as a Profile, is about
	DelSarefIsAbout(...owl.Thing) error // delete A relationship identifying what an entity, such as a Profile, is about
}

// timeNumericDurationSinglefloat64 is interface for property TimeNumericDuration with single type float64
type timeNumericDurationSinglefloat64 interface {
	TimeNumericDuration() float64 // Value of a temporal extent expressed as a decimal number scaled by a temporal unit
	SetTimeNumericDuration(float64) error // set Value of a temporal extent expressed as a decimal number scaled by a temporal unit
}

// sarefConsistsOfMultipleTimeTemporalEntity is interface for property SarefConsistsOf with multiple type TimeTemporalEntity
type sarefConsistsOfMultipleTimeTemporalEntity interface {
	SarefConsistsOf() []TimeTemporalEntity // A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
	SetSarefConsistsOf([]TimeTemporalEntity) error // set A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
	AddSarefConsistsOf(...TimeTemporalEntity) error // add A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
	DelSarefConsistsOf(...TimeTemporalEntity) error // delete A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
}

// timeDaysSinglefloat64 is interface for property TimeDays with single type float64
type timeDaysSinglefloat64 interface {
	TimeDays() float64 // length of, or element of the length of, a temporal extent expressed in days
	SetTimeDays(float64) error // set length of, or element of the length of, a temporal extent expressed in days
}

// timeHoursSinglefloat64 is interface for property TimeHours with single type float64
type timeHoursSinglefloat64 interface {
	TimeHours() float64 // length of, or element of the length of, a temporal extent expressed in hours
	SetTimeHours(float64) error // set length of, or element of the length of, a temporal extent expressed in hours
}

// timeMinutesSinglefloat64 is interface for property TimeMinutes with single type float64
type timeMinutesSinglefloat64 interface {
	TimeMinutes() float64 // length, or element of, a temporal extent expressed in minutes
	SetTimeMinutes(float64) error // set length, or element of, a temporal extent expressed in minutes
}

// timeMonthsSinglefloat64 is interface for property TimeMonths with single type float64
type timeMonthsSinglefloat64 interface {
	TimeMonths() float64 // length of, or element of the length of, a temporal extent expressed in months
	SetTimeMonths(float64) error // set length of, or element of the length of, a temporal extent expressed in months
}

// timeSecondsSinglefloat64 is interface for property TimeSeconds with single type float64
type timeSecondsSinglefloat64 interface {
	TimeSeconds() float64 // length of, or element of the length of, a temporal extent expressed in seconds
	SetTimeSeconds(float64) error // set length of, or element of the length of, a temporal extent expressed in seconds
}

// timeWeeksSinglefloat64 is interface for property TimeWeeks with single type float64
type timeWeeksSinglefloat64 interface {
	TimeWeeks() float64 // length of, or element of the length of, a temporal extent expressed in weeks
	SetTimeWeeks(float64) error // set length of, or element of the length of, a temporal extent expressed in weeks
}

// timeYearsSinglefloat64 is interface for property TimeYears with single type float64
type timeYearsSinglefloat64 interface {
	TimeYears() float64 // length of, or element of the length of, a temporal extent expressed in years
	SetTimeYears(float64) error // set length of, or element of the length of, a temporal extent expressed in years
}

// sarefHasMeterReadingMultipleSarefMeasurement is interface for property SarefHasMeterReading with multiple type SarefMeasurement
type sarefHasMeterReadingMultipleSarefMeasurement interface {
	SarefHasMeterReading() []SarefMeasurement // A relationship between a metering function and the measurement of the reading
	SetSarefHasMeterReading([]SarefMeasurement) error // set A relationship between a metering function and the measurement of the reading
	AddSarefHasMeterReading(...SarefMeasurement) error // add A relationship between a metering function and the measurement of the reading
	DelSarefHasMeterReading(...SarefMeasurement) error // delete A relationship between a metering function and the measurement of the reading
}

// sarefHasMeterReadingTypeMultipleThing is interface for property SarefHasMeterReadingType with multiple type owl.Thing
type sarefHasMeterReadingTypeMultipleThing interface {
	SarefHasMeterReadingType() []owl.Thing // A relationship identifying the reading type of a measurement (e.g., Water, Gas, Pressure , Energy , Power, etc.)
	SetSarefHasMeterReadingType([]owl.Thing) error // set A relationship identifying the reading type of a measurement (e.g., Water, Gas, Pressure , Energy , Power, etc.)
	AddSarefHasMeterReadingType(...owl.Thing) error // add A relationship identifying the reading type of a measurement (e.g., Water, Gas, Pressure , Energy , Power, etc.)
	DelSarefHasMeterReadingType(...owl.Thing) error // delete A relationship identifying the reading type of a measurement (e.g., Water, Gas, Pressure , Energy , Power, etc.)
}

// sarefRelatesToPropertyMultipleSarefProperty is interface for property SarefRelatesToProperty with multiple type SarefProperty
type sarefRelatesToPropertyMultipleSarefProperty interface {
	SarefRelatesToProperty() []SarefProperty // A relationship between a measurement and the property it relates to
	SetSarefRelatesToProperty([]SarefProperty) error // set A relationship between a measurement and the property it relates to
	AddSarefRelatesToProperty(...SarefProperty) error // add A relationship between a measurement and the property it relates to
	DelSarefRelatesToProperty(...SarefProperty) error // delete A relationship between a measurement and the property it relates to
}

// sarefHasTimestampMultipleTime is interface for property SarefHasTimestamp with multiple type time.Time
type sarefHasTimestampMultipleTime interface {
	SarefHasTimestamp() []time.Time // A relationship stating the timestamp of an entity (e.g. a measurement).
	SetSarefHasTimestamp([]time.Time) error // set A relationship stating the timestamp of an entity (e.g. a measurement).
	AddSarefHasTimestamp(...time.Time) error // add A relationship stating the timestamp of an entity (e.g. a measurement).
	DelSarefHasTimestamp(...time.Time) error // delete A relationship stating the timestamp of an entity (e.g. a measurement).
}

// sarefHasValueSinglefloat64 is interface for property SarefHasValue with single type float64
type sarefHasValueSinglefloat64 interface {
	SarefHasValue() float64 // A relationship defining the value of a certain property, e.g., energy or power
	SetSarefHasValue(float64) error // set A relationship defining the value of a certain property, e.g., energy or power
}

// timeInXSDDateTimeStampSingleTime is interface for property TimeInXSDDateTimeStamp with single type time.Time
type timeInXSDDateTimeStampSingleTime interface {
	TimeInXSDDateTimeStamp() time.Time // Position of an instant, expressed using xsd:dateTimeStamp
	SetTimeInXSDDateTimeStamp(time.Time) error // set Position of an instant, expressed using xsd:dateTimeStamp
}

// timeInXSDgYearMonthSingleTime is interface for property TimeInXSDgYearMonth with single type time.Time
type timeInXSDgYearMonthSingleTime interface {
	TimeInXSDgYearMonth() time.Time // Position of an instant, expressed using xsd:gYearMonth
	SetTimeInXSDgYearMonth(time.Time) error // set Position of an instant, expressed using xsd:gYearMonth
}

// timeInTemporalPositionSingleTimeTemporalPosition is interface for property TimeInTemporalPosition with single type TimeTemporalPosition
type timeInTemporalPositionSingleTimeTemporalPosition interface {
	TimeInTemporalPosition() TimeTemporalPosition // Position of a time instant
	SetTimeInTemporalPosition(TimeTemporalPosition) error // set Position of a time instant
}

// timeInXSDDateTimeSingleTime is interface for property TimeInXSDDateTime with single type time.Time
type timeInXSDDateTimeSingleTime interface {
	TimeInXSDDateTime() time.Time // Position of an instant, expressed using xsd:dateTime
	SetTimeInXSDDateTime(time.Time) error // set Position of an instant, expressed using xsd:dateTime
}

// timeInXSDDateSingleTime is interface for property TimeInXSDDate with single type time.Time
type timeInXSDDateSingleTime interface {
	TimeInXSDDate() time.Time // Position of an instant, expressed using xsd:date
	SetTimeInXSDDate(time.Time) error // set Position of an instant, expressed using xsd:date
}

// timeInDateTimeSingleTimeGeneralDateTimeDescription is interface for property TimeInDateTime with single type TimeGeneralDateTimeDescription
type timeInDateTimeSingleTimeGeneralDateTimeDescription interface {
	TimeInDateTime() TimeGeneralDateTimeDescription // Position of an instant, expressed using a structured description
	SetTimeInDateTime(TimeGeneralDateTimeDescription) error // set Position of an instant, expressed using a structured description
}

// timeInXSDgYearSingleTime is interface for property TimeInXSDgYear with single type time.Time
type timeInXSDgYearSingleTime interface {
	TimeInXSDgYear() time.Time // Position of an instant, expressed using xsd:gYear
	SetTimeInXSDgYear(time.Time) error // set Position of an instant, expressed using xsd:gYear
}

// timeInTimePositionSingleTimePosition is interface for property TimeInTimePosition with single type TimePosition
type timeInTimePositionSingleTimePosition interface {
	TimeInTimePosition() TimePosition // Position of an instant, expressed as a temporal coordinate or nominal value
	SetTimeInTimePosition(TimePosition) error // set Position of an instant, expressed as a temporal coordinate or nominal value
}


